#include "StdAfx.h"
#include "04WebServer.h"
#include "connection.h"
#include "threadskeleton.h"
#include "server.h"
#include "dateutility.h"
#include "intervaltimer.h"
#include "StringCompare.h"
#include "Dir.h"
#include "subprocess.h"
#include "SSLSocket.h"

#include "systemresponse.h"
#include "normalresponse.h"
#include "directoryresponse.h"
#include "fileresponse.h"
#include "cgiresponse.h"
#include "ssiresponse.h"

#include "davpropfindresponse.h"
#include "fileputresponse.h"
#include "filedeleteresponse.h"
#include "filemoveresponse.h"
#include "optionsresponse.h"
#include "keyswapstring.h"


CConnection::CConnection(CServer *server,CMySocket *socket)
: m_interrupt(this)
{
	//	ϐ
	m_server = server;
	m_maxKeepAliveTime = m_server->m_setting.GetConfig("Basic::KeepAliveTime",20) * 1000;
	m_keepAlive = m_server->m_setting.GetConfig("Basic::EnableKeepAlive",0);

	//	\Pbgݒ
	m_socket = socket;

	//	XbhJn
	if(StartThread())
		throw CConnectionException("Xbh̊JnɎs܂");
}

CConnection::~CConnection(void)
{
	EndThread();

	delete m_socket;
	m_socket = NULL;
}

//!	^CAEg
void CConnection::OnTimeOut()
{
	//	ؒf
	m_socket->Close();

	CTimeOut::OnTimeOut();
}

//!	f
void CConnection::Break()
{
	//	ؒf
	m_socket->Close();

	CThreadSkeleton::Break();
}

/*!
	ڑ
*/
void CConnection::ThreadMain()
{
	DWORD		lastAccess = GetTickCount();
	CIPAddress	peer = m_socket->GetPeerAddres();

	//	SSL֘Ȁ
	if(SSLTask())
		return;

	while(1)
	{
		//	ANZX́H
		char temp;
		if(m_socket->CanRecv() && m_socket->Peek(&temp,1) && !m_socket->IsDisconnect())
		{
			//	V
			CConfigAccess context = NewContext();

			//	PNGXg̏s
			try
			{
				//	
				m_sendSize = 0;
				m_recvSize = 0;
				m_recvDataSize = 0;

				//	ڑ
				int KeepAlive = OneRequest(context);

				//	]ʋL^
				UpdateTransSize(context);

				//	ɏÎŃT[oOɏo
				WriteLog(context);

				//	폜
				DeleteContext(context);

				//	ؒfH
				if(KeepAlive == 0)
					break;
			}
			catch(CServerFatalException e)
			{
				//	]ʋL^
				UpdateTransSize(context);

				//	ؒf̕Kv̂G[̂ŁAOɃG[o
				context.SetConfig("Info",e.m_info);
				WriteLog(context);

				//	폜
				DeleteContext(context);
				return;
			}

			//	ANZX̂ŁAKeepAliveԂ
			lastAccess = GetTickCount();
		}
		else
		{
			//	}^[
			Sleep(20);
		}

		//	ؒfH
		if(m_socket->IsDisconnect())
			break;

		//	KeepAlive͗Lł͂ȂH
		if(m_keepAlive==0)
			break;

		//	keepAlive^CAEgH
		if(lastAccess + m_maxKeepAliveTime < GetTickCount())
			break;
	}

	m_socket->Close();
}

/*!
	SSL֘Ȁs
*/
int CConnection::SSLTask()
{
	//	SSL?
	if(m_socket->IsSSL())
	{
		//	SSLlSVG[V
		if(((CSSLSocket *)m_socket)->SSLAccept())
			return(-1);
	}
	return(0);
}

/*!
	PNGXg̏s
*/
int CConnection::OneRequest(CConfigAccess context)
{
	/*
		NGXg̎MƉ͂s
	*/
	//	zXg
	context.SetConfig("Host",(CString)m_socket->GetPeerAddres());

	//	wb_[̎M
	CString		header = RecvHeader();

	//	NGXg̉
	CRequest	request(header,context.GetAccess("RequestInfo"));

	//	^[QbgzXg
	context.SetConfig("TargetHost",request.m_options.GetConfig("Host",""));

	//	pX̉
	CAlias		alias(request.m_uriObject,request.m_options.GetConfig("Host",""),m_server->m_setting);

	//	ш敝Ǘ
	CBandWidthReference	bandRef(m_server->GetCBandWidthMgr(),m_socket->GetPeerAddres(),context.GetConfig("ThreadName",""));

	//	X|X
	CResponse *use = NULL;

	//	Keep-Alivẻ
	int KeepAlive;
	if(request.m_options.GetConfig("Connection","",TRUE).CompareNoCase("keep-alive") == 0)
		KeepAlive = 1;
	else
		KeepAlive = 0;


	//	T[o[G[XR[v(500)
	try
	{
		//	T[o[X|XXR[v(301,404 etc...)
		try
		{
			//	WX|XXR[v
			try
			{
				//	[U[F؁EڑȂǁAANZX`FbN
				CheckAccess(context,request,alias,bandRef);

				//	WebDAV
				WebDAV(context,request,alias);

				//	ړH
				if(alias.IsMove())
				{
					CSystemResponse *move = new CSystemResponse(m_server,context,alias.GetMoveTo() + " ɈړĂ",301);
					move->m_responseOptions.SetConfig("Location",alias.GetMoveTo());
					throw move;
				}

				//	fBNg\H
				if(alias.IsDirectory())
					throw new CDirectoryResponse(m_server,context,request,alias);

				//	CGI?
				CGI(context,request,alias);

				//	SSI?
				SSI(context,request,alias);

				//	ŏI̓t@C
				throw new CFileResponse(m_server,context,request,alias);
			}
			catch(CNormalResponse *response)
			{
				//	OÃXR[vō폜
				use = response;

				//	X|XM
				SendResponse(context,request,alias,bandRef,response);
				delete response;

				//	bZ[W
				context.SetConfig("Info","ɏI܂");

				//	I
				return KeepAlive;
			}
		}
		catch(CSystemResponse *response)
		{
			//	̃XR[ṽf[^폜
			if(use != NULL)
				delete use;

			//	OÃXR[vō폜
			use = response;

			//	X|XM
			SendResponse(context,request,alias,bandRef,response);
			
			//	bZ[W
			context.SetConfig("Info",response->GetInfo());

			delete response;

			//	I
			return KeepAlive;
		}
	}
	catch(CServerFatalException e)
	{
		//	̃XR[ṽf[^폜
		if(use != NULL)
			delete use;

		//	vIT[oG[
		SendFatalError(e.m_info);

		//	G[o^
		context.SetConfig("ResponseInfo::ResponseCode",500);
		context.SetConfig("ResponseInfo::ResponseText",CResponse::GetHTTPResponseString(500));

		//	ɓ
		throw CServerFatalException(e.m_info);
	}
	catch(CMemoryException *err)
	{
		err->Delete();

		//	̃XR[ṽf[^폜
		if(use != NULL)
			delete use;

		//	vIT[oG[
		SendFatalError("NGXg̏ɁAs܂");

		//	G[o^
		context.SetConfig("ResponseInfo::ResponseCode",500);
		context.SetConfig("ResponseInfo::ResponseText",CResponse::GetHTTPResponseString(500));

		//	ɓ
		throw CServerFatalException("NGXg̏ɁAs܂");
	}

	//	ɂ͗Ȃ
	ASSERT(0);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	X|X쐬
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*!
 *	ANZXL`FbN
 */
void CConnection::CheckAccess(CConfigAccess &context,CRequest &request,CAlias &alias,CBandWidthReference &bandRef)
{
	//	HTTPSsH
	if(m_socket->IsSSL() && alias.GetPathOptions().GetConfig("AcceptHTTPS",1)==0)
		throw new CSystemResponse(m_server,context,"HTTPS ̃ANZX́AĂ܂",403);

	//	HTTPsH
	if(m_socket->IsSSL()==0 && alias.GetPathOptions().GetConfig("AcceptHTTP",1)==0)
		throw new CSystemResponse(m_server,context,"HTTP ̃ANZX́AĂ܂",403);

	//	LbNH
	if(CheckKickHost(context,request,alias))
		throw new CSystemResponse(m_server,context,"zXg " + context.GetConfig("Host","") + " ̃ANZX́AĂ܂",403);
		
	//	ڑ`FbN
	if(bandRef.IsLimitOver())
		throw new CSystemResponse(m_server,context,"PzXg̍őڑ𒴂܂",503);

	//	Bt@C͖H
	if(alias.GetPathOptions().GetConfig("EnableHiddenFile",0) == 0 && alias.IsHidden())
		throw new CSystemResponse(m_server,context,"̃t@CEfBNgւ̃ANZX́AĂ܂",403);

	//	[U[`FbN
	CheckUser(context,request,alias);
}

/*!
 *	WebDAV
 */
void CConnection::WebDAV(CConfigAccess &context,CRequest &request,CAlias &alias)
{
	//	Options
	if(request.m_method == "OPTIONS")
		throw new COptionsResponse(m_server,context,request,alias);

	//	WebDAV͗L?
	if(alias.GetPathOptions().GetConfig("EnableWebDAV",0))
	{
		if(request.m_method == "PROPFIND")
			throw new CDAVPropfindResponse(m_server,context,request,alias);
		else if(request.m_method == "PROPPATCH")
			throw CServerFatalException("T|[gĂ܂");
		else if(request.m_method == "LOCK")
			throw CServerFatalException("T|[gĂ܂");
		else if(request.m_method == "UNLOCK")
			throw CServerFatalException("T|[gĂ܂");
	}

	//	݂͗LH
	if(alias.GetPathOptions().GetConfig("EnableWrite",0))
	{
		if(request.m_method == "PUT")
			throw new CFilePutResponse(m_server,context,request,alias);
		else if(request.m_method == "MKCOL")
			throw new CFilePutResponse(m_server,context,request,alias);
		else if(request.m_method == "DELETE")
			throw new CFileDeleteResponse(m_server,context,request,alias);
		else if(request.m_method == "COPY")
			throw new CFileMoveResponse(m_server,context,request,alias);
		else if(request.m_method == "MOVE")
			throw new CFileMoveResponse(m_server,context,request,alias);
	}
}


/*!
	CGI
*/
void CConnection::CGI(CConfigAccess &context,CRequest &request,CAlias &alias)
{
	//	t@C͂̂H
	if(!alias.IsExist()  && !alias.IsExtarExist())
		return;

	//	CGI͋Ă̂H
	if(alias.GetPathOptions().GetConfig("EnableSSICGI",0))
	{
		//	ʏ
		CString command = CSubProcess::GetCGICommand(m_server,alias.GetTarget(),request.m_queryDecoded);

		//	GNXgpX
		if(command.IsEmpty() && alias.IsExtarExist())
			command = CSubProcess::GetCGICommand(m_server,alias.GetExtraTarget(),request.m_queryDecoded);

		if(!command.IsEmpty())
		{
			context.SetConfig("ScriptCommand",command);
			throw new CCGIResponse(m_server,context,request,alias,m_interrupt);
		}
	}
}


/*!
	SSI
*/
void CConnection::SSI(CConfigAccess &context,CRequest &request,CAlias &alias)
{
	//	t@C͂̂H
	if(!alias.IsExist())
		return;

	//	SSI͋Ă̂H
	if(alias.GetPathOptions().GetConfig("EnableSSICGI",0))
	{
		//	gq̎擾
		CString	ext = CDir::PathToExt(alias.GetTarget());

		//	ݒ胊Xg擾
		CConfigAccess	ssiSetting = m_server->m_setting.GetAccess("SSI");
		CStringArray	ssiList;
		ssiSetting.GetAllKey(ssiList);

		//	eݒ
		for(int i=0;i<ssiList.GetSize();i++)
		{
			if(ext.CompareNoCase(ssiSetting.GetConfig(ssiList[i],"")) == 0)
				throw new CSSIResponse(m_server,context,request,alias,m_interrupt);
		}
	}
}

/*!
	LbNzXg`FbN
*/
int CConnection::CheckKickHost(CConfigAccess &context,CRequest &request,CAlias &alias)
{
	CConfigAccess	kick = alias.GetPathInfo().GetAccess("Kick");
	CString			hostIP = m_socket->GetPeerAddres();

	//	LH
	if(alias.GetPathOptions().GetConfig("EnableHostKick",0))
	{
		//	܂͋֎~Ă邩`FbN
		CConfigAccess	denied = kick.GetAccess("Denied");
		CStringArray	list;
		denied.GetAllKey(list);

		for(int i=0;i<list.GetSize();i++)
		{
			if(CStringCompare::WildCompare(denied.GetConfig(list[i],""),hostIP))
				return(1);
		}

		//	Ă邩`FbN
		CConfigAccess	accept = kick.GetAccess("Accept");
		accept.GetAllKey(list);

		for(int i=0;i<list.GetSize();i++)
		{
			if(CStringCompare::WildCompare(accept.GetConfig(list[i],""),hostIP))
				return(0);
		}

		return(1);
	}

	return(0);
}


/*!
 *	[U[̃`FbN
 *
 */
void CConnection::CheckUser(CConfigAccess &context,CRequest &request,CAlias &alias)
{
	if(alias.GetPathOptions().GetConfig("EnableAuthenticate",0))
	{
		CString	username = request.m_user;
		if(alias.GetPathOptions().GetConfig("EnableWebDAV",0))
		{
			//	WindowsXP ΍
			int index = username.Find("\\");
			if(index != -1)
				username = username.Mid(index+1);
		}

		if(CheckUser(username,request.m_passwd,alias)==0)
		{
			CSystemResponse *move = new CSystemResponse(m_server,context,"F؂Kvł",401);
			CString str;
			str.Format("Basic realm=\"%s\"",alias.GetPathInfo().GetConfig("Info",""));
			move->m_responseOptions.SetConfig("WWW-Authenticate",str);
			throw move;
		}
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	X|X
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*!
 *	wb_[̎M
 *
 */
CString CConnection::RecvHeader()
{
	//	̊֐Ń^CAEg\
	TIMEOUT_SCOPE();

	CString	header;
	int		index = 0;

	//	wb_[M
	while(1)
	{
		//	Mf[^̃`FbN
		if(m_socket->PeekString(header)<0)
			throw CServerFatalException("wb_[Mɐؒf̓lbg[NG[܂");

		//	I`FbN
		index = header.Find("\r\n\r\n");
		if(index != -1)
			break;
		
		//	ُȃwb_r
		if(m_socket->GetInRecvBuf() > 32000)
			throw CServerFatalException("ُȃwb_[M܂");

		//	ؒfƂAfƂ̊荞݂́H
		if(m_interrupt.IsInterrupt())
			throw CServerFatalException("wb_[M" + m_interrupt.GetInterruptInfo());

		Sleep(20);
	}

	//	wb_[
	if(m_socket->RecvString(header,index + 4)<0)
			throw CServerFatalException("wb_[Mɐؒf̓lbg[NG[܂");

	//	MTCY
	m_recvSize += header.GetLength();

	return(header);
}

/*!
	X|X̏
*/
void CConnection::SendResponse(CConfigAccess &context,CRequest &request,CAlias &alias,CBandWidthReference &bandRef,CResponse *response)
{
	//	bZ[W
	context.SetConfig("Info","X|Xf[^̑O...");

	//	X|X
	response->PreCreateResponse();

	//	X|X{fB[̎M
	RecvData(context,request,alias,bandRef,response);

	//	X|X𐶐
	context.SetConfig("Info","X|Xf[^̐...");
	response->CreateResponse();

	//	X|X̎擾
	CConfigAccess responseInfo = response->GetResponseInfo();
	CConfigAccess responseOptions = responseInfo.GetAccess("Options");

	//	̎擾
	__int64 length = response->GetResponseSize();
	responseOptions.SetConfig("Content-Length",length);

	//	wb_̐
	CString header = MakeHeaderString(responseInfo);

	//	bZ[W
	context.SetConfig("Info","wb_[̑Mł...");

	//	wb_̑M
	if(m_socket->SendString(header)<0)
		throw CServerFatalException("wb_[Mɐؒf̓lbg[NG[܂");

	//	wb_TCY
	m_sendSize += header.GetLength();

	//	{fB[M
	SendData(context,request,alias,bandRef,response,length);
}

/*!
	NGXg{fB[M
*/
void CConnection::RecvData(CConfigAccess &context,CRequest &request,CAlias &alias,CBandWidthReference &bandRef,CResponse *response)
{
	context.SetConfig("Info","f[^̎MJnĂ܂...");

	//	̊֐Ń^CAEg\
	TIMEOUT_SCOPE();

	//	MTCÝH
	__int64 len = _atoi64(request.m_options.GetConfig("Content-Length","0",TRUE));
	__int64	orgLen;

	//	2ڂ̌Ăяỏ\l(c̃f[^݂̂擾)
	len -= m_recvDataSize;
	orgLen = len;

	//	~bg̐ݒ
	bandRef.SetRecvLimit(alias.GetPathOptions().GetConfig("EnableBandWidthLimit",0));

	//	M
	int					recv;
	CBuffer				data;
	CBandWidthLimit		limiter;
	CIntervalTimer		timer(1000);
	while(len > 0)
	{
		//	PeekBufɓǂݍł݂
		if(m_socket->RecvToPeekBuf() < 0)
			throw CServerFatalException("f[^Mɐؒf̓lbg[NG[܂");

		//	PeekBuftAcTCY܂őSǂݍ
		if(m_socket->PeekBufIsFull() || m_socket->InPeekBuf() >= len)
		{
			int inPeekBuf = m_socket->InPeekBuf();

			data.ReSize(inPeekBuf);
			if(len > inPeekBuf)
				recv = m_socket->Recv(data,inPeekBuf);
			else
				recv = m_socket->Recv(data,(int)len);

			if(recv < 0)
				throw CServerFatalException("f[^Mɐؒf̓lbg[NG[܂");

			data.ReSize(recv);
			response->SetNextData(data);
			len -= recv;
			m_recvSize += recv;
			m_recvDataSize += recv;

			//	ш搧ɂEFCg
			Delay(limiter.GetWaitTick(bandRef.GetCurrentRecvLimit(),recv));
			limiter.OneTracsEnd();

			//	
			if(timer)
			{
				int limit = bandRef.GetCurrentRecvLimit();

				CString	str;
				if(!limit)
					str.Format("M : %I64dK/%I64dK [%I64d%%] (%0.1fK/Sec)",orgLen - len,orgLen,(orgLen - len) * 100 / orgLen,(double)limiter.GetCurSpeed()/1024.0);
				else
					str.Format("M : %I64dK/%I64dK [%I64d%%] (%0.1fK/S, Limit: %0.1fK/S)",orgLen - len,orgLen,(orgLen - len) * 100 / orgLen,(double)limiter.GetCurSpeed()/1024.0,(double)limit/1024.0);
				context.SetConfig("Info",str);
			}

			TIMEOUT_RESET();
		}
		else
			Sleep(20);	//	}^[

		//	ؒfƂAfƂ̊荞݂́H
		if(m_interrupt.IsInterrupt())
			throw CServerFatalException("f[^M" + m_interrupt.GetInterruptInfo());
	}

	//	~bg
	bandRef.SetRecvLimit(0);
}

/*!
	X|X{fB[𑗐M
*/
void CConnection::SendData(CConfigAccess &context,CRequest &request,CAlias &alias,CBandWidthReference &bandRef,CResponse *response,__int64 length)
{
	context.SetConfig("Info","f[^̑MJnĂ܂...");

	//	̊֐Ń^CAEg\
	TIMEOUT_SCOPE();

	//	~bg̐ݒ
	bandRef.SetSendLimit(alias.GetPathOptions().GetConfig("EnableBandWidthLimit",0));


	//	Body̑M
	CBuffer			data(65536);
	CBandWidthLimit	limiter;
	CIntervalTimer	timer(1000);
	__int64			sended = 0;
	while(1)
	{
		TIMEOUT_RESET();
		int size = response->GetNextData(data);

		if(size <= 0)
			break;



		if(data.GetSize() > 0)
		{
			if(m_socket->Send(data,size)<0)
			{
				throw CServerFatalException("f[^Mɐؒf̓lbg[NG[܂");
			}
			m_sendSize += size;
			sended += size;
		}


		//	ؒfƂAfƂ̊荞݂́H
		if(m_interrupt.IsInterrupt())
			throw CServerFatalException("f[^M" + m_interrupt.GetInterruptInfo());

		//	ш搧ɂEFCg
		Delay(limiter.GetWaitTick(bandRef.GetCurrentSendLimit(),size));
		limiter.OneTracsEnd();

		//	
		if(timer)
		{
			int limit = bandRef.GetCurrentSendLimit();

			CString	str;
			if(!limit)
				str.Format("M : %I64dK/%I64dK [%I64d%%] (%0.1fK/Sec)",sended,length,sended * 100 / length,(double)limiter.GetCurSpeed()/1024.0);
			else
				str.Format("M : %I64dK/%I64dK [%I64d%%] (%0.1fK/S, Limit: %0.1lfK/S)",sended,length,sended * 100 / length,(double)limiter.GetCurSpeed()/1024.0,(double)limit/1024.0);
			context.SetConfig("Info",str);
		}

	}

	//	~bg
	bandRef.SetRecvLimit(0);

}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	⏕֐
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*!
	wb_̐
*/
CString CConnection::MakeHeaderString(CConfigAccess responseInfo)
{
	CConfigAccess responseOptions = responseInfo.GetAccess("Options");
	CString	header,line;

	//	X|XC
	line.Format("HTTP/1.1 %s\r\n",responseInfo.GetConfig("ResponseText","500 Internal Server Error"));
	header += line;

	//	IvVC
	CStringArray	keyList;
	responseOptions.GetAllKey(keyList);
	for(int i=0;i<keyList.GetSize();i++)
	{
		line.Format("%s: %s\r\n",keyList[i],responseOptions.GetConfig(keyList[i],""));
		header += line;
	}

	//	CGIpwb_
	CString cgiHeader = responseInfo.GetConfig("CGIHeader","");
	header += cgiHeader;
	header += "\r\n";

	return(header);
}


/*!
	vIG[̏
*/
void CConnection::SendFatalError(CString info)
{
	//	̊֐Ń^CAEg\
	TIMEOUT_SCOPE();

	CString	body;
	body.Format("<HTML><HEAD>"\
				"<TITLE>500 Internal Server Error</TITLE>"\
				"<meta http-equiv=\"Content-Type\" content=\"text/html;charset=Shift_JIS\"></HEAD>\n"\
				"<BODY><H1>Error : 500 Internal Server Error</H1>"\
				"<PRE>%s</PRE>"\
				"<HR><ADDRESS>04WebServer/"SERVER_VER"</ADDRESS>"\
				"</BODY></HTML>",info);

	CString	head;
	head.Format("HTTP/1.0 500 Internal Server Error\r\n"\
				"Server: 04WebServer/"SERVER_VER"\r\n"\
				"Content-Type: text/html\r\n"\
				"Connection: Close\r\n"\
				"Content-length: %d\r\n"\
				"\r\n",body.GetLength());

	m_socket->SendString(head);
	m_socket->SendString(body);
	m_socket->Close();
}


/*!
	VReLXg̎擾
*/
CConfigAccess CConnection::NewContext()
{
	//	[NXy[X쐬
	CString	name;
	name.Format("Thread_%04x",m_server->GetNewID());

	CConfigAccess	ret = m_server->m_threadContext.GetAccess(name);
	ret.SetConfig("ThreadName",name);

	//	쐬ݒ
	CConfigAccess	date = ret.GetAccess("StartTime");
	date.Copy(GetDate());

	//	bZ[W
	ret.SetConfig("Info","ł...");

	//	^Cv
	if(m_socket->IsSSL())
	{
		ret.SetConfig("Protocol","https");
	}
	else
	{
		ret.SetConfig("Protocol","http");
	}

	return(ret);
}

/*!
	O
*/
void CConnection::WriteLog(CConfigAccess &context)
{
	//	uƃ\[Xݒ
	CKeySwapString	swapper;
	CString			format = m_server->m_setting.GetConfig("Log::LogFormatNoTime","[%Time%] <%Host%> (%RecvSize%,%SendSize%) [%Info%] %Method% %Object%");
	swapper.SetString(format);

	CConfigAccess	request = context.GetAccess("RequestInfo");
	CConfigAccess	response = context.GetAccess("ResponseInfo");

	//	Userݒ肳ĂȂꍇ "-" ɒu
	if(request.GetConfig("User","").IsEmpty())
		swapper.Swap("User","-");

	//	ReLXg
	swapper.Swap(context);

	//	W
	swapper.Swap(request);
	swapper.Swap(response);

	swapper.Swap(request.GetAccess("Options"));
	swapper.Swap(response.GetAccess("Options"));

	//	s폜
	CString	logLine = swapper.GetString("-");
	logLine.Replace("\n","_");
	logLine.Replace("\r","_");

	m_server->m_log.WriteLog("%s",logLine);
}


/*!
	ReLXg̔j
*/
void CConnection::DeleteContext(CConfigAccess context)
{
	CString	name = context.GetConfig("ThreadName","");
	int max = m_server->m_setting.GetConfig("Log::MaxThreadLog",10);

	//	t̎擾
	CConfigAccess	date = context.GetAccess("EndTime");
	date.Copy(GetDate());

	if(max > 0)
	{
		//	bN
		LOCK_CONFIG(m_server->m_threadContextLog);

		//	̈̃Rs[
		CConfigAccess	log = m_server->m_threadContextLog.GetAccess(name);
		log.Copy(context);

		//	O̒
		if(m_server->m_threadContextLog.GetSubNodeCount() > max)
		{
			CStringArray	array;
			m_server->m_threadContextLog.GetAllSubNode(array);
			m_server->m_threadContextLog.DeleteNode(array[0]);
		}
	}

	//	̍폜
	m_server->m_threadContext.DeleteNode(name);
}


//	]ʂL^
void CConnection::UpdateTransSize(CConfigAccess &context)
{
	//	]ʓo^
	m_server->AddTrans(m_sendSize,m_recvSize);

	//	TCY̋L^
	context.SetConfig("RecvSize",m_recvSize);
	context.SetConfig("SendSize",m_sendSize);
	context.SetConfig("Size",m_recvSize + m_sendSize);
}



/*!
 *	t擾
 *
 *	@param	detail	1:ڍחL
 *	@return			̈
 */
CConfigAccess CConnection::GetDate(int detail)
{
	//	̈擾
	CConfigAccess date = m_date.GetAccess("Date");
	date.Clear();

	//	
	CTime	time=CTime::GetCurrentTime();
	date.SetConfig("Date",time.Format("%Y/%m/%d"));
	date.SetConfig("Time",time.Format("%H:%M:%S"));
	date.SetConfig("GMT",CDateUtility::GetGMTString(time));

	if(detail)
	{
		date.SetConfig("Year",time.Format("%Y"));
		date.SetConfig("Month",time.Format("%m"));
		date.SetConfig("Day",time.Format("%d"));
		date.SetConfig("DayOfWeek",time.Format("%w"));

		date.SetConfig("MonthString",time.Format("%b"));
		date.SetConfig("DayOfWeekString",time.Format("%a"));

		date.SetConfig("Hour",time.Format("%H"));
		date.SetConfig("Minute",time.Format("%M"));
		date.SetConfig("Second",time.Format("%S"));

	}
	return(date);
}


/*!
 *	[U[̃`FbN
 */
int CConnection::CheckUser(CString userName,CString passwd,CAlias alias)
{
	CConfigAccess	pathUser = alias.GetPathInfo().GetAccess("Users");
	CConfigAccess	enableUser = m_server->m_setting.GetAccess("User::Enable");

	//	
	CStringArray	userList;
	pathUser.GetAllKey(userList);
	for(int i=0;i<userList.GetSize();i++)
	{
		if(pathUser.GetConfig(userList[i],"") == userName)
			goto next;
	}
	return 0;

next:

	//	
	enableUser.GetAllSubNode(userList);
	for(int i=0;i<userList.GetSize();i++)
	{
		CConfigAccess user = enableUser.GetAccess(userList[i]);
		if(user.GetConfig("User","") == userName && user.GetConfig("Passwd","") == passwd)
			return 1;
	}
	return 0;
}


/*!
 *	EFCg
 */
void CConnection::Delay(int tick)
{
	DWORD	endTick = GetTickCount() + tick;

	while(!m_interrupt.IsInterrupt())
	{
		int subTick = endTick - GetTickCount();
		
		if(subTick <= 0)
		{
			break;
		}
		else if(subTick < 20)
		{
			Sleep(subTick);
			break;
		}
		else
			Sleep(20);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	荞݊ǗNX
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CConnectionInterrupt::CConnectionInterrupt(CConnection *connection)
{
	m_connection = connection;
}

CConnectionInterrupt::CConnectionInterrupt(CConnectionInterrupt &other)
{
	m_connection = other.m_connection;
	m_interruptInfo = other.m_interruptInfo;
}

//	荞݂H
int CConnectionInterrupt::IsInterrupt()
{
	//	^CAEg`FbN
	if(m_connection->IsTimeOut())
	{
		m_interruptInfo = "^CAEg܂";
		return(1);
	}

	//	ؒf`FbN
	if(m_connection->m_socket->IsDisconnect())
	{
		m_interruptInfo = "ؒf܂";
		return(1);
	}

	//	f`FbN
	if(m_connection->GetBreak())
	{
		m_interruptInfo = "f܂";
		return(1);
	}

	return(0);
}

//	Iy[^
CConnectionInterrupt::operator int()
{
	return(IsInterrupt());
}

//	擾
CString CConnectionInterrupt::GetInterruptInfo()
{
	return(m_interruptInfo);
}

