#pragma once
#include "SortArray.h"
#include "Buffer.h"
#include "Workspace.h"

class CCommandPacket
{
public:
	CCommandPacket(void);
	CCommandPacket(CCommandPacket &other);
	virtual ~CCommandPacket(void);

	void operator=(CCommandPacket &other);

	////////////////////////////////////////////////////////////////////////////////////
	//	ϊ
	////////////////////////////////////////////////////////////////////////////////////
	//!	obt@f[^\z
	int FromBuffer(CBuffer &data);

	//!	obt@f[^֕ϊ
	void ToBuffer(CBuffer &data);


	////////////////////////////////////////////////////////////////////////////////////
	//	{̐ݒ
	////////////////////////////////////////////////////////////////////////////////////
	//!	R}hݒ
	void SetCommand(CString command);

	//!	R}h擾
	CString GetCommand();

	//!	IvVڂ̐ݒ
	void SetCommandOption(CString key, CString data);

	//!	IvVڂ̐ݒ
	void SetCommandOptionInt(CString key, int data);

	//!	IvVڂ̎擾
	CString GetCommandOption(CString key, CString data = "");

	//!	IvVڂ̎擾
	int GetCommandOptionInt(CString key, int data = 0);
	

	////////////////////////////////////////////////////////////////////////////////////
	//	܂Ƃ߂ďݒ
	////////////////////////////////////////////////////////////////////////////////////
	//!	I
	void SetSuccessPacket();

	//!	G[
	void SetErrorPacket(int errorCode, CString errorInfo);

	////////////////////////////////////////////////////////////////////////////////////
	//	`FbN
	////////////////////////////////////////////////////////////////////////////////////
	//!	H
	int IsSuccess();

	////////////////////////////////////////////////////////////////////////////////////
	//	ANZX擾
	////////////////////////////////////////////////////////////////////////////////////
	//!	{
	CWorkspaceAccess	GetBasicDataAccess() { return m_xmlBasicData; };

	//!	tf[^
	CWorkspaceAccess	GetAttachedDataAccess() { return m_xmlAttachedData; };


protected:
	////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	////////////////////////////////////////////////////////////////////////////////////
	//!	{
	CWorkspaceAccess	m_xmlBasicData;

	//!	tf[^
	CWorkspaceAccess	m_xmlAttachedData;

	////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	////////////////////////////////////////////////////////////////////////////////////
	//!	XMLf[^
	CWorkspace			m_xmlRoot;

	//!	XML[gփANZX
	CWorkspaceAccess	m_xmlRootAccess;
};
